<template>
  <div class="parameter-form">
    <ob-modal
        v-if="current"
        ref="ob-modal"
        :title="modalTitle"
        :size="'medium'"
        :isShowControls="true"
        :isConfirm="false"
        :isSubmitDisabled="!validValue"
        @cancel="close"
        @submit="onSave"
        class="sb-popup sb-card-popup param-modal"
      >
        <ob-form
            :isShowControls="false"
            :formData="formData"
        >
            <ob-selector
                class="edit-method"
                :items="parameters"
                :placeholder="'Выберите'"
                :label="'Выбор параметра методики'"
                v-model="formData.parameterUuid"
                @selected="sendUnit"
                :disabled="Boolean(parameterForChange)"
            />
            <div class="parameter-form__container parameter-form__time" v-if="unitType === 'HARD'">
                <div>
                    <strong>Коридоры значений параметра</strong>
                        <ob-input
                            class="edit-method"
                            :label="'Кол-во коридоров значений'"
                            :placeholder="'Введите'"
                            type="text"
                            v-model="value"
                            @input="addValue(value, 'pushedValues')"
                            :labelInfo="'Максимум 6'"
                            :isValid="validPoints"
                            :mask="'9'"
                        />
                        <ob-selector
                            class="edit-method"
                            :label="'Ед.измерения'"
                            :placeholder="this.unitName"
                            disabled
                        />
                    <div class="table">
                        <div class="table__row" v-for="(item, i) in pushedValues" :key="i">
                            <ob-input
                                class="item"
                                :label="'От'"
                                :placeholder="''"
                                type="text"
                                required
                                v-if="updateFlag"
                                :value="pushedValues[i].from"
                                :isValid="pushedValues[i].fromIsValid"
                                @input="checkInput($event, pushedValues, i, 'from')"
                                :disabled="true"
                            />
                            <ob-input
                                class="item"
                                :label="'До'"
                                :placeholder="'Введите значение'"
                                type="text"
                                required
                                v-if="updateFlag"
                                :value="pushedValues[i].to"
                                :isValid="pushedValues[i].toIsValid"
                                @input="checkInput($event, pushedValues, i, 'to')"
                            />
                            <ob-input
                                class="item"
                                :label="'Баллы'"
                                :placeholder="'Введите значение'"
                                type="text"
                                required
                                v-if="updateFlag"
                                :value="pushedValues[i].value"
                                :isValid="pushedValues[i].valueIsValid"
                                @input="checkInput($event, pushedValues, i, 'value', 'point')"
                            />
                        </div>
                    </div>
                    <div class="">Значение "До" должно быть больше значения "От". Для последнего коридора допускается значение "До", равное "-" (при отсутствии верхней границы коридора)</div>
                    <div class="text-red pt-small" v-if="isPointError">Допустимое значение баллов: от 0 до 5</div>
                </div>
                <div class="pt-small">
                    <strong>Коридоры значений параметра</strong>
                        <ob-input
                            class="edit-method"
                            :label="'Кол-во коридоров значений'"
                            :placeholder="'Введите'"
                            type="text"
                            v-model="valueHard"
                            @input="addValue(valueHard, 'secondPushedValues')"
                            :labelInfo="'Максимум 5'"
                            :isValid="validScores"
                            :mask="'9'"
                        />
                    <div class="table">
                        <div class="table__row" v-for="(item, i) in secondPushedValues" :key="i">
                            <ob-input
                                class="item"
                                :label="'От'"
                                :placeholder="''"
                                type="text"
                                required
                                v-if="updateFlag"
                                :value="secondPushedValues[i].from"
                                :isValid="secondPushedValues[i].fromIsValid"
                                @input="checkInput($event, secondPushedValues, i, 'from')"
                                :disabled="true"
                            />
                            <ob-input
                                class="item"
                                :label="'До'"
                                :placeholder="'Введите значение'"
                                type="text"
                                v-if="updateFlag"
                                required
                                :value="secondPushedValues[i].to"
                                :isValid="secondPushedValues[i].toIsValid"
                                @input="checkInput($event, secondPushedValues, i, 'to')"
                            />
                            <ob-input
                                class="item"
                                :label="'Вес'"
                                :placeholder="'Введите значение'"
                                type="text"
                                v-if="updateFlag"
                                required
                                :value="secondPushedValues[i].value"
                                :isValid="secondPushedValues[i].valueIsValid"
                                @input="handleScoreInput($event, i)"
                                :mask="'9.9'"
                                isMasked
                            />
                        </div>
                    </div>
                    <div class="">Значение "До" должно быть больше значения "От". Для последнего коридора допускается значение "До", равное "-" (при отсутствии верхней границы коридора)</div>
                    <div class="text-red pt-small" v-if="isScoreSumError">Сумма весов коридоров значений должна равняться 1, нулевые значения не допускаются</div>
                </div>
            </div>

            <div class="parameter-form__container" v-if="unitType === 'SIMPLE'">
                <strong>Коридоры значений параметра</strong>
                    <ob-input
                        class="edit-method"
                        :label="'Кол-во коридоров значений'"
                        :placeholder="'Введите'"
                        type="number"
                        v-model="value"
                        @input="addValue(value, 'pushedValues')"
                        :labelInfo="'Максимум 6'"
                        :isValid="validPoints"
                        :mask="'9'"
                    />
                    <ob-selector
                        class="edit-method"
                        :label="'Ед.измерения'"
                        :placeholder="this.unitName"
                        disabled
                    />
                <div class="table">
                    <!-- <p class="table__header">Задайте коридор значений</p> -->
                    <div class="table__row" v-for="(item, i) in pushedValues" :key="i">
                        <ob-input
                            class="item"
                            :label="'От'"
                            :placeholder="''"
                            type="text"
                            required
                            v-if="updateFlag"
                            :isValid="pushedValues[i].fromIsValid"
                            :value="pushedValues[i].from"
                            @input="checkInput($event, pushedValues, i, 'from')"
                            :disabled="true"
                        />
                        <ob-input
                            class="item"
                            :label="'До'"
                            :placeholder="'Введите значение'"
                            type="text"
                            v-if="updateFlag"
                            :isValid="pushedValues[i].toIsValid"
                            :value="pushedValues[i].to"
                            required
                            @input="checkInput($event, pushedValues, i, 'to')"
                        />
                        <ob-input
                            class="item"
                            :label="'Баллы'"
                            :placeholder="'Введите значение'"
                            type="text"
                            v-if="updateFlag"
                            required
                            :isValid="pushedValues[i].valueIsValid"
                            :value="pushedValues[i].value"
                            @input="checkInput($event, pushedValues, i, 'value', 'point')"
                        />
                    </div>
                </div>
                <div class="">Значение "До" должно быть больше значения "От". Для последнего коридора допускается значение "До", равное "-" (при отсутствии верхней границы коридора)</div>
                <div class="text-red pt-small" v-if="isPointError">Допустимое значение баллов: от 0 до 5</div>
            </div>

            <div class="parameter-form__container" v-if="unitType === 'BINARY'">
                    <ob-selector
                        class="edit-method"
                        :label="'Ед.измерения'"
                        :placeholder="this.unitName"
                        disabled
                    />
                <div class="table">
                    <p class="table__header">Задайте баллы для значений "Да" и "Нет"</p>
                    <div class="table__row">
                        <ob-input
                            class="double"
                            :label="'Значение'"
                            type="text"
                            value='Да'
                            disabled
                        />
                        <ob-input
                            class="double"
                            :label="'Баллы'"
                            :placeholder="'Введите значение'"
                            type="text"
                            required
                            v-model="pointIfTrue"
                            :mask="'9'"
                        />
                    </div>
                    <div class="table__row">
                        <ob-input
                            class="double"
                            :label="'Значение'"
                            type="text"
                            value='Нет'
                            disabled
                        />
                        <ob-input
                            class="double"
                            :label="'Баллы'"
                            :placeholder="'Введите значение'"
                            type="text"
                            required
                            v-model="pointIfFalse"
                            :mask="'9'"
                        />
                    </div>
                </div>
            </div>

            <div class="parameter-form__container" v-if="unitType === 'EXCLUDE'">
                <p class="table__description">Если этот параметр имеет значение "Да", то рейтинг за весь заказ становится равен нулю.</p>
                <ob-radio
                    style="padding: 5px 0;"
                    label="Не учитывать этот параметр"
                    :value-input="false"
                    v-model="excludeValue"
                />
                <ob-radio
                    style="padding: 5px 0;"
                    label="Учитывать этот параметр"
                    :value-input="true"
                    v-model="excludeValue"
                />                
            </div>
        </ob-form>
        <div v-if="isOnSaveError" class="text-red">В настоящее время нельзя сохранить настройки параметра рейтингования</div>
    </ob-modal>
  </div>
</template>

<script>
import { uuid } from 'vue-uuid'
import ObForm from "common-components/src/obComponents/obForm";
import ObModal from 'common-components/src/obComponents/obModal';
import ObSelector from 'common-components/src/obComponents/obSelect';
import ObInput from 'common-components/src/obComponents/obInput';
import ObRadio from 'common-components/src/obComponents/obRadio'
// eslint-disable-next-line no-unused-vars
import { CREATE_PARAMETER, UPDATE_PARAMETER } from '../../../store/modules/parameter';

export default {
  data() {
      return {
        value: '4',
        valueHard: '4',
        formData: {
            parameterUuid: '',
        },
        unitName: '',
        unitType: '',
        pushedValues: [],
        secondPushedValues: [],
        pointIfTrue: '',
        pointIfFalse: '',
        excludeValue: false,
        isOnSaveError: false,
        isScoreSumError: false,
        isPointError: false,
        updateFlag: true,
      }
  },
  props: {
    parameterForChange: {
      type: [Object, Boolean],
      default: false,
    }
  },
  components: {
    ObForm,
    ObModal,
    ObSelector,
    ObInput,
    ObRadio
  },
  computed: {
    current() {
        return this.$store.getters.getCurrentMethodology;
    },
    parameters() {
        return this.$store.getters.getParameters;
    },
    validValue() {
        let isValid = false
        if (this.unitType === 'SIMPLE') {
            const isValidPoints = this.validateAllCells(this.pushedValues)
            isValid = isValidPoints && this.validPoints
        } else if (this.unitType === 'HARD') {
            const isValidPoints = this.validateAllCells(this.pushedValues)
            const isValidScores = this.validateAllCells(this.secondPushedValues)
            isValid = isValidPoints && isValidScores && this.validPoints && this.validScores
        } else if (this.unitType === 'BINARY') {
            if ((this.pointIfTrue || this.pointIfTrue === 0 || this.pointIfTrue === '0') && (this.pointIfFalse || this.pointIfFalse === 0 || this.pointIfFalse === '0')) {
                isValid = true
            }
        } else if (this.unitType === 'EXCLUDE') {
            isValid = true
        }
        return isValid
    },
    validPoints() {
        if (this.value > 6 || this.value <= 0) return false
        else return true
    },
    validScores() {
        if (this.valueHard > 5 || this.valueHard <= 0) return false
        else return true
    },
    modalTitle() {
        if (this.parameterForChange) {
            return 'Параметр методики (редактировать)'
        }
        return 'Параметр методики (добавить новый)'
    },
  },
  watch: {
      async value() {
          this.updateFlag = false
          await this.$nextTick()
          this.updateFlag = true
      },
      async valueHard() {
          this.updateFlag = false
          await this.$nextTick()
          this.updateFlag = true
      }
  },
  methods: {
    validateAllCells(data) {
        let isValid = 1
        data.map((item) => {
            for (let prop in item) {
                if (prop === 'fromIsValid' || prop === 'toIsValid' || prop === 'valueIsValid') {
                    if (item[prop] === false) {
                        isValid  *= 0
                    }
                }
            }
        })
        if (!data.length) {
            isValid = false
        }
        return Boolean(isValid)
    },
    checkInput(value, arr, i, prop, type = 'range') {
        arr[i][`${prop}IsValid`] = false

        if (type === 'range') {
            const isFirstFromInRange = i === 0 && prop === 'from'
            const isLastToInRange = i === arr.length - 1 && prop === 'to'
            if (isFirstFromInRange || isLastToInRange) {
                if (Number.isInteger(+value) || value === '-') {
                    arr[i][prop] = value
                    arr[i][`${prop}IsValid`] = true
                }
            } else {
                if (Number.isInteger(+value) && +value >= 0) {
                    arr[i][prop] = value
                    arr[i][`${prop}IsValid`] = true
                }
            }

            if (prop === 'to' && !isLastToInRange) {
                arr[i + 1]['from'] = (+value + 1).toString()
                arr[i + 1]['fromIsValid'] = true
            }
        }

        if (type === 'point') {
            this.isPointError = false
            if (Number.isInteger(+value) && +value >= 0 && +value <= 5) {
                arr[i][prop] = value
                arr[i][`${prop}IsValid`] = true
            } else {
                this.isPointError = true
            }
        }

        this.validateInputs()
    },
    handleScoreInput(value, i) {
        this.secondPushedValues[i].value = +value
        this.checkScoreSum()
    },
    checkScoreSum() {
        let sum = 0
        this.secondPushedValues.map((item) => {
            if (!item.value) {
                sum -= 500 // makes sum not valid any case
            } else {
                sum += item.value
            }
        })
        sum = Math.round(sum * 10) / 10
        if (sum === 1) {
            for (let i = 0; i < this.secondPushedValues.length; i++) {
                this.secondPushedValues[i].valueIsValid = true
            }
            this.isScoreSumError = false
            return true // sum is valid
        } else {
            for (let i = 0; i < this.secondPushedValues.length; i++) {
                this.secondPushedValues[i].valueIsValid = false
            }
            this.isScoreSumError = true
        }
        return false
    },
    validateInputs() {
        function validateRanges(ranges) {
            for (let i = 0; i < ranges.length; i++) {
                const row = ranges[i]
                if (+row.to <= +row.from) {
                    row.toIsValid = false
                    row.fromIsValid = false
                } else {
                    row.toIsValid = true
                    row.fromIsValid = true
                }
                if (i === ranges.length - 1) {
                    if (Number.isInteger(+row.from) && row.to === '-') {
                        row.toIsValid = true
                        row.fromIsValid = true
                    }
                }
            }
        }
        validateRanges(this.pushedValues)
        validateRanges(this.secondPushedValues)
    },
    /**
     * @param {Number} length
     * @param {String} destinationName
     */
    addValue(length, destinationName) {
      const keys = ['from', 'fromIsValid', 'to', 'toIsValid', 'value', 'valueIsValid'];
      const filtered = keys
          .map(item => {
              if (item === 'fromIsValid' || item === 'toIsValid' || item === 'valueIsValid') {
                  return ({ [item]: false })
              }
              return ({ [item]: '' })}
          )
          .reduce((acc, item) => ({ ...acc, ...item}), {})
      const values = []
      for (let i = 0; i < length; i++) {
          values.push({...filtered, i})
      }
      values[0].from = '-'
      this[destinationName] = values
    },

    async onSave() {
        this.isOnSaveError = false
        function clearRedundantEls(item, type) {
          const cleared = {
              [type]: item.value,
          }
          if (item.to !== '-') {
              cleared.to = item.to
          }
          if (item.from !== '-') {
              cleared.from = item.from
          }
          return cleared
        }

        const ranges = this.pushedValues.map((item) => {
            return clearRedundantEls(item, 'point')
        });
        const scores = this.secondPushedValues.map((item) => {
            return clearRedundantEls(item, 'score')
        })
        
        const initialState = {
            parameterUuid: this.formData.parameterUuid,
        }
        if (this.parameterForChange) {
            //
        } else {
            initialState.uuid = uuid.v4()
        }

        const payload = () => {
            switch (this.unitType) {
                case 'SIMPLE':
                    return { ...initialState, value: { ranges }}
                case 'HARD':
                    return { ...initialState, value: { 
                        pointRanges: ranges,
                        scoreRanges: scores
                    }}
                case 'BINARY':
                    return { ...initialState, value: { 
                        pointIfTrue: this.pointIfTrue,
                        pointIfFalse: this.pointIfFalse
                    }}
                case 'EXCLUDE':
                    return { ...initialState, value: { 
                        excludeValue: this.excludeValue
                    }}
                default:
                    break
            }
        }
        try {
            let res;
            if (this.parameterForChange) {
                res = await this.$store.dispatch(UPDATE_PARAMETER, {
                    methodology_uuid: this.current.uuid,
                    parameter_value_uuid: this.parameterForChange.uuid,
                    value: payload()
                })
            } else {
                res = await this.$store.dispatch(CREATE_PARAMETER, { uuid: this.current.uuid, payload: payload() })
            }
            if (res.error) {
                this.isOnSaveError = true
            } else {
                this.close()
            }
        } catch (ex) {
            console.log(ex)
        }
    },
    async sendUnit(data) {
        this.updateFlag = false
        await this.$nextTick()
        this.updateFlag = true
        this.clearParameterForm()
        this.addValue(this.value, 'pushedValues')
        this.addValue(this.valueHard, 'secondPushedValues')
        this.unitName = data.unitOfMeasurement === "CONVENTIONAL_UNIT" ? "Условная единица" :
                        data.unitOfMeasurement === "MINUTE" ? "Минута" : 
                        data.unitOfMeasurement === "HOUR" ? "Час" : 
                        data.unitOfMeasurement === "DAY" ? "День" : 
                        data.unitOfMeasurement === "PIECES" ? "Штука" : 
                        data.unitOfMeasurement === "PERCENT" ? "Процент" : 
                        data.unitOfMeasurement === "NUMBER_OF_TIMES" ? "Количество раз" : ""
        this.unitType = data.type
    },
    async open(data) {
        this.formData = {
            parameterUuid: '',
        }
        this.clearParameterForm()
        this.updateFlag = false
        await this.$nextTick()
        this.updateFlag = true
        if (this.parameterForChange) {
            this.unitType = this.parameterForChange.parameter.type
            this.fillParameterForm()
        } else {
            this.unitType = ''
            this.addValues()
        }
        this.$refs['ob-modal'].open()
        if (uuid) {
            this.formData.uuid = data
        }
    },
    addValues() {
        this.addValue(this.value, 'pushedValues')
        this.addValue(this.valueHard, 'secondPushedValues')
    },
    close() {
        this.formData = {
            parameterUuid: '',
        }
        this.clearParameterForm()
        this.$refs['ob-modal'].close()
    },
    clearParameterForm() {
        this.value = '4'
        this.valueHard = '4'
        this.unitName = ''
        this.unitType = ''
        this.pushedValues = []
        this.secondPushedValues = []
        this.pointIfTrue = ''
        this.pointIfFalse = ''
        this.excludeValue = false
        this.isOnSaveError = false
        this.isScoreSumError = false
        this.isPointError = false
    },
    fillParameterForm() {
        this.formData.parameterUuid = this.parameterForChange.parameter.uuid
        switch (this.parameterForChange.parameter.type) {
            case 'HARD':
                this.value = this.parameterForChange.value.pointRanges.length
                this.valueHard = this.parameterForChange.value.scoreRanges.length
                this.addValues()
                for (let i = 0; i < this.pushedValues.length; i++) {
                    const row = this.pushedValues[i]
                    const from = this.parameterForChange.value.pointRanges[i].from
                    const to = this.parameterForChange.value.pointRanges[i].to
                    if (!from || from === '0') {
                        row.from = '-'
                    } else {
                        row.from = from
                    }
                    if (to === undefined || to === null) {
                        row.to = '-'
                    } else if (to === '0' || to === 0) {
                        row.to = '0'
                    } else {
                        row.to = to
                    }
                    row.value = this.parameterForChange.value.pointRanges[i].point
                    row.fromIsValid = true
                    row.toIsValid = true
                    row.valueIsValid = true
                }
                for (let i = 0; i < this.secondPushedValues.length; i++) {
                    const row = this.secondPushedValues[i]
                    const from = this.parameterForChange.value.scoreRanges[i].from
                    const to = this.parameterForChange.value.scoreRanges[i].to
                    if (!from || from === '0') {
                        row.from = '-'
                    } else {
                        row.from = from
                    }
                    if (to === undefined || to === null) {
                        row.to = '-'
                    } else if (to === '0' || to === 0) {
                        row.to = '0'
                    } else {
                        row.to = to
                    }
                    row.value = this.parameterForChange.value.scoreRanges[i].score
                    row.fromIsValid = true
                    row.toIsValid = true
                    row.valueIsValid = true
                }
                break
            case 'SIMPLE':
                this.value = this.parameterForChange.value.ranges.length
                this.addValues()
                for (let i = 0; i < this.pushedValues.length; i++) {
                    const row = this.pushedValues[i]
                    const from = this.parameterForChange.value.ranges[i].from
                    const to = this.parameterForChange.value.ranges[i].to
                    if (!from || from === '0') {
                        row.from = '-'
                    } else {
                        row.from = from
                    }
                    if (to === undefined || to === null) {
                        row.to = '-'
                    } else if (to === '0' || to === 0) {
                        row.to = '0'
                    } else {
                        row.to = to
                    }
                    row.value = this.parameterForChange.value.ranges[i].point
                    row.fromIsValid = true
                    row.toIsValid = true
                    row.valueIsValid = true
                }
                break
            case 'BINARY':
                this.pointIfTrue = this.parameterForChange.value.pointIfTrue
                if (this.parameterForChange.value.pointIfFalse === 0) {
                    this.pointIfFalse = '0'
                } else {
                    this.pointIfFalse = this.parameterForChange.value.pointIfFalse
                }
                break
            case 'EXCLUDE':
                this.excludeValue = this.parameterForChange.value.excludeValue
                break
            default:
                // unreachable here
        }
    },
    checkBinaryInputs() {
        console.log(123)
    },
  },
}
</script>

<style lang="scss" scoped>
.parameter-form {
    display: flex;
    padding-top: 10px;
    &__container {
        width: 100%;
    }
    &__time {
        padding-right: 10px;
    }
    //noinspection CssInvalidPseudoSelector
    &:v-deep {
        .ob-modal-container {
            min-width: min-content;
        }
    }
}
.param-modal {
    min-width: min-content;
}
.edit-method {
    // display: flex;
    padding: 10px 0;
    // justify-content: space-between;
    &__label {
        width: 80%;
    }
    &__input {
        width: 20%;
    }
    &__input {
        margin: 0;
    }
    &__check {
        align-self: center;
        margin: auto;
    }
    &__wrap {
        flex-wrap: wrap;
        width: 100%;
        .text-field {
            width: 100%;
            overflow-y: scroll;
            resize: none;
            border: 1px solid #D1D2D6;
            border-radius: 3px;
        }
    }
}
.table {
    padding: 10px 0;
    display: flex;
    flex-wrap: wrap;
    width: 100%;
    max-height: 50vh;
    overflow-y: scroll;
    &__row {
        width: 100%;
        display: flex;
        flex-wrap: wrap;
        .item {
            width: 33.33%;
        }
        .double{ 
            width: 50%;
        }
    }
    &__header {
        width: 100%;
    }
    &__description {
        padding: 5px 0;
        color: #737682;
        font-size: 13px;
    }
}

.text-red {
    color: red;
}

.pt-small {
    padding-top: 8px;
}

</style>
